Index: testsuite/src/resources/jbossts/resources/postgres92-xa-ds.xml
===================================================================
--- testsuite/src/resources/jbossts/resources/postgres92-xa-ds.xml	(revision 0)
+++ testsuite/src/resources/jbossts/resources/postgres92-xa-ds.xml	(working copy)
@@ -0,0 +1,12 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<datasources>
+  <xa-datasource>
+    <jndi-name>CrashRecoveryDS</jndi-name>
+    <track-connection-by-tx>true</track-connection-by-tx> 
+    <xa-datasource-class>org.postgresql.xa.PGXADataSource</xa-datasource-class>
+    <xa-datasource-property name="ServerName">db14.mw.lab.eng.bos.redhat.com</xa-datasource-property>
+    <xa-datasource-property name="PortNumber">5432</xa-datasource-property>
+    <xa-datasource-property name="DatabaseName">crashrec</xa-datasource-property>
+    @CREDENTIALS@
+  </xa-datasource>
+</datasources>

Property changes on: testsuite/src/resources/jbossts/resources/postgres92-xa-ds.xml
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+text/xml
\ No newline at end of property
Index: testsuite/src/resources/jbossts/resources/postgresplus92-xa-ds.xml
===================================================================
--- testsuite/src/resources/jbossts/resources/postgresplus92-xa-ds.xml	(revision 0)
+++ testsuite/src/resources/jbossts/resources/postgresplus92-xa-ds.xml	(working copy)
@@ -0,0 +1,12 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<datasources>
+  <xa-datasource>
+    <jndi-name>CrashRecoveryDS</jndi-name>
+    <track-connection-by-tx>true</track-connection-by-tx> 
+    <xa-datasource-class>com.edb.xa.PGXADataSource</xa-datasource-class>
+    <xa-datasource-property name="ServerName">db15.mw.lab.eng.bos.redhat.com</xa-datasource-property>
+    <xa-datasource-property name="PortNumber">5432</xa-datasource-property>
+    <xa-datasource-property name="DatabaseName">crashrec</xa-datasource-property>
+    @CREDENTIALS@
+  </xa-datasource>
+</datasources>

Property changes on: testsuite/src/resources/jbossts/resources/postgresplus92-xa-ds.xml
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+text/xml
\ No newline at end of property
Index: testsuite/src/resources/jbossts/scripts/as-tests.xml
===================================================================
--- testsuite/src/resources/jbossts/scripts/as-tests.xml	(revision 114581)
+++ testsuite/src/resources/jbossts/scripts/as-tests.xml	(working copy)
@@ -75,6 +75,12 @@
     <condition property="want.psql_9.1">
        <equals arg1="${jbossts.db}" arg2="psql_9.1"/>
     </condition>
+    <condition property="want.psql_9.2">
+       <equals arg1="${jbossts.db}" arg2="psql_9.2"/>
+    </condition>
+    <condition property="want.psqlplus_9.2">
+       <equals arg1="${jbossts.db}" arg2="psqlplus_9.2"/>
+    </condition>  	
     <condition property="want.sybase_15">
        <equals arg1="${jbossts.db}" arg2="sybase_15"/>
     </condition>
@@ -131,6 +137,8 @@
   	<property name="want.psql_8.4" value="true" />
   	<property name="want.psql_9.0" value="true" />
   	<property name="want.psql_9.1" value="true" />
+  	<property name="want.psql_9.2" value="true" />
+  	<property name="want.psqlplus_9.2" value="true" />
   	<property name="want.sybase_15" value="true" />
   	<property name="want.sybase_15.5" value="true" />
   	<property name="want.oracle_10" value="true" />
@@ -219,6 +227,8 @@
   	<antcall target="call-tests-for-psql_8.4"/>
   	<antcall target="call-tests-for-psql_9.0"/>
   	<antcall target="call-tests-for-psql_9.1"/>
+  	<antcall target="call-tests-for-psql_9.2"/>
+  	<antcall target="call-tests-for-psqlplus_9.2"/>
   	<antcall target="call-tests-for-oracle_10"/>
   	<antcall target="call-tests-for-oracle_11"/>
   	<antcall target="call-tests-for-oracle_11_r2"/>
@@ -276,7 +286,23 @@
    	  <param name="dbname" value="psql91" /> 
     </antcall>
   </target>
-
+	
+  <target name="call-tests-for-psql_9.2" if="want.psql_9.2">
+    <antcall target="${call.target}">
+      <param name="dbdriver" value="${driver.name.psql_9.2}"/>
+      <param name="datasource" value="postgres92-xa-ds.xml" /> 
+   	  <param name="dbname" value="psql92" /> 
+    </antcall>
+  </target>
+	
+  <target name="call-tests-for-psqlplus_9.2" if="want.psqlplus_9.2">
+    <antcall target="${call.target}">
+      <param name="dbdriver" value="${driver.name.psqlplus_9.2}"/>
+      <param name="datasource" value="postgresplus92-xa-ds.xml" /> 
+   	  <param name="dbname" value="psqlplus92" /> 
+    </antcall>
+  </target>
+	
   <target name="call-tests-for-oracle_10" if="want.oracle_10">
   	<antcall target="${call.target}">
   	  <param name="dbdriver" value="${driver.name.oracle_10}"/>
@@ -757,6 +783,8 @@
     <property name="driver.name.psql_8.4" value="postgresql-8.4.jar"/>
     <property name="driver.name.psql_9.0" value="postgresql-9.0.jar"/>
     <property name="driver.name.psql_9.1" value="postgresql-9.1.jar"/>
+    <property name="driver.name.psql_9.2" value="postgresql-9.2.jar"/> <!-- driver.url is http://www.qa.jboss.com/jdbc-drivers-products/EAP/6.2.0 -->
+    <property name="driver.name.psqlplus_9.2" value="postgresqlplus-9.2.jar"/> <!-- driver.url is http://www.qa.jboss.com/jdbc-drivers-products/EAP/6.2.0 -->
     <property name="driver.name.sybase_15" value="jconn4.jar"/>
     <property name="driver.name.oracle_10" value="ojdbc14.jar"/>
     <property name="driver.name.oracle_11" value="ojdbc6.jar"/>
@@ -767,7 +795,7 @@
     <property name="driver.name.mssql_2005" value="sqljdbc4_2005.jar"/>
     <property name="driver.name.mssql_2008" value="sqljdbc4_2008.jar"/>
     <property name="driver.name.mssql_2008_r2" value="sqljdbc4_2008_r2.jar"/>
-    <property name="driver.name.mssql_2012" value="sqljdbc4_20012.jar"/> <!-- driver.url on http://www.qa.jboss.com/jdbc-drivers-products/EAP/6.1.0 -->
+    <property name="driver.name.mssql_2012" value="sqljdbc4_20012.jar"/> <!-- driver.url is http://www.qa.jboss.com/jdbc-drivers-products/EAP/6.2.0 -->
 	
     <target name="prepare-drivers">
        <available file="${driver.home}/${driver.name.psql_8.2}" property="have.dbdriver.psql_8.2" value="true"/>      
@@ -775,6 +803,8 @@
        <available file="${driver.home}/${driver.name.psql_8.4}" property="have.dbdriver.psql_8.4" value="true"/>      
        <available file="${driver.home}/${driver.name.psql_9.0}" property="have.dbdriver.psql_9.0" value="true"/>
        <available file="${driver.home}/${driver.name.psql_9.1}" property="have.dbdriver.psql_9.1" value="true"/>
+       <available file="${driver.home}/${driver.name.psql_9.2}" property="have.dbdriver.psql_9.2" value="true"/>
+       <available file="${driver.home}/${driver.name.psqlplus_9.2}" property="have.dbdriver.psqlplus_9.2" value="true"/>
        <available file="${driver.home}/${driver.name.sybase_15}" property="have.dbdriver.sybase_15" value="true"/>
        <available file="${driver.home}/${driver.name.oracle_10}" property="have.dbdriver.oracle_10" value="true"/>   	
        <available file="${driver.home}/${driver.name.oracle_11}" property="have.dbdriver.oracle_11" value="true"/>      
@@ -821,6 +851,9 @@
                  get.driver.mssql_2012,
                  get.driver.psql_9.0,
                  get.driver.psql_9.1,
+                 get.driver.psql_9.2,
+                 get.driver.psqlplus_9.2,
+                 get.driver.psql_9.2,
                  get.driver.psql_8.4,
                  get.driver.psql_8.3,
                  get.driver.psql_8.2,
@@ -873,10 +906,18 @@
         <get src="${driver.url}/postgresql82/jdbc4/postgresql-8.2-511.jdbc4.jar"
              dest="${driver.home}/${driver.name.psql_8.2}"/>
     </target>
-	<target name="get.driver.psql_9.1" unless="have.dbdriver.psql_9.1" if="want.psql_9.1">
-	        <get src="${driver.url}/postgresql91/jdbc4/postgresql-9.1-902.jdbc4.jar"
-	             dest="${driver.home}/${driver.name.psql_9.1}"/>
-	</target>
+    <target name="get.driver.psql_9.1" unless="have.dbdriver.psql_9.1" if="want.psql_9.1">
+        <get src="${driver.url}/postgresql91/jdbc4/postgresql-9.1-902.jdbc4.jar"
+             dest="${driver.home}/${driver.name.psql_9.1}"/>
+    </target>
+    <target name="get.driver.psql_9.2" unless="have.dbdriver.psql_9.2" if="want.psql_9.2">
+        <get src="${driver.url}/postgresql92/jdbc4/postgresql-9.2-1002.jdbc4.jar"
+             dest="${driver.home}/${driver.name.psql_9.2}"/>
+    </target>
+    <target name="get.driver.psqlplus_9.2" unless="have.dbdriver.psqlplus_9.2" if="want.psqlplus_9.2">
+    <get src="${driver.url}/postgresplus92/jdbc4/edb-jdbc14.jar"
+         dest="${driver.home}/${driver.name.psqlplus_9.2}"/>
+    </target>
     <target name="get.driver.mysql_5.1" unless="have.dbdriver.mysql_5.1" if="want.mysql_5.1">
         <get src="${driver.url}/mysql55/jdbc4/mysql-connector-java-5.1.21-bin.jar"
              dest="${driver.home}/${driver.name.mysql_5.1}"/>