Index: testsuite/src/test/java/org/jboss/ejb3/test/composite/EntityTestBean.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/composite/EntityTestBean.java	(revision 114651)
+++ testsuite/src/test/java/org/jboss/ejb3/test/composite/EntityTestBean.java	(working copy)
@@ -41,6 +41,22 @@
    private @PersistenceContext EntityManager manager;
    private static long genid = 0;
 
+   public Flight createFlight(final long flightId, final String flightName){
+      Flight flight = new Flight();
+      flight.setId(flightId);
+      flight.setName(flightName);
+      manager.persist(flight);
+      return flight;
+   }
+   
+   public FieldFlight createFieldFlight(final long fieldFlightId, final String fieldFlightName){
+      FieldFlight fieldFlight = new FieldFlight();
+      fieldFlight.setId(fieldFlightId);
+      fieldFlight.setName(fieldFlightName);
+      manager.persist(fieldFlight);
+      return fieldFlight;
+   }
+
    public Customer oneToManyCreate(String name) throws Exception
    {
       Ticket t = new Ticket();
@@ -63,21 +79,14 @@
 
    public Flight manyToOneCreate() throws Exception
    {
-      Flight firstOne = new Flight();
-      firstOne.setId(new Long(1));
-      firstOne.setName("AF0101");
-      manager.persist(firstOne);
-      return firstOne;
+      return createFlight(1l, "AF0101");
    }
 
    public void manyToManyCreate() throws Exception
    {
+      Flight firstOne = createFlight(2, "AF0103");
+      Flight second = createFlight(3, "US1");
 
-      Flight firstOne = findFlightById(new Long(1));
-      Flight second = new Flight();
-      second.setId(new Long(2));
-      second.setName("US1");
-
       Set<Customer> customers1 = new HashSet<Customer>();
       Set<Customer> customers2 = new HashSet<Customer>();
 
@@ -132,21 +141,14 @@
 
    public FieldFlight fieldManyToOneCreate() throws Exception
    {
-      FieldFlight firstOne = new FieldFlight();
-      firstOne.setId(new Long(1));
-      firstOne.setName("AF0101");
-      manager.persist(firstOne);
-      return firstOne;
+      return createFieldFlight(1l, "AF0101");
    }
 
    public void fieldManyToManyCreate() throws Exception
    {
+      FieldFlight firstOne = createFieldFlight(2, "KL800");
+      FieldFlight second = createFieldFlight(3, "US1"); 
 
-      FieldFlight firstOne = fieldFindFlightById(new Long(1));
-      FieldFlight second = new FieldFlight();
-      second.setId(new Long(2));
-      second.setName("US1");
-
       Set<FieldCustomer> customers1 = new HashSet<FieldCustomer>();
       Set<FieldCustomer> customers2 = new HashSet<FieldCustomer>();
 
Index: testsuite/src/test/java/org/jboss/ejb3/test/composite/unit/EntityUnitTestCase.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/composite/unit/EntityUnitTestCase.java	(revision 114651)
+++ testsuite/src/test/java/org/jboss/ejb3/test/composite/unit/EntityUnitTestCase.java	(working copy)
@@ -86,8 +86,8 @@
       EntityTest test = (EntityTest) this.getInitialContext().lookup("EntityTestBean/remote");
       test.manyToManyCreate();
 
-      Flight one = test.findFlightById(new Long(1));
-      Flight two = test.findFlightById(new Long(2));
+      Flight one = test.findFlightById(new Long(2));
+      Flight two = test.findFlightById(new Long(3));
 
       System.out.println("Air France customers");
       for (Customer c : one.getCustomers())
@@ -136,10 +136,10 @@
       EntityTest test = (EntityTest) this.getInitialContext().lookup("EntityTestBean/remote");
       test.fieldManyToManyCreate();
 
-      FieldFlight one = test.fieldFindFlightById(new Long(1));
-      FieldFlight two = test.fieldFindFlightById(new Long(2));
+      FieldFlight one = test.fieldFindFlightById(new Long(2));
+      FieldFlight two = test.fieldFindFlightById(new Long(3));
 
-      System.out.println("Air France customers");
+      System.out.println("KL800 customers");
       for (FieldCustomer c : one.getCustomers())
       {
          System.out.println(c.getName());
Index: testsuite/src/test/java/org/jboss/ejb3/test/manytomany/EntityTestBean.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/manytomany/EntityTestBean.java	(revision 114651)
+++ testsuite/src/test/java/org/jboss/ejb3/test/manytomany/EntityTestBean.java	(working copy)
@@ -41,6 +41,17 @@
 {
    private @PersistenceContext EntityManager manager;
 
+   public Flight createFlight(long flightId, String flightName, String companyName){
+      Flight flight = new Flight();
+      flight.setId(flightId);
+      flight.setName(flightName);
+      Company company = new Company();
+      company.setName(companyName);
+      flight.setCompany(company);
+      manager.persist(flight);
+      return flight;
+   }
+
    public Customer oneToManyCreate() throws Exception
    {
       Ticket t = new Ticket();
@@ -69,26 +80,14 @@
 
    public Flight manyToOneCreate() throws Exception
    {
-      Flight firstOne = new Flight();
-      firstOne.setId(new Long(1));
-      firstOne.setName("AF0101");
-      Company frenchOne = new Company();
-      frenchOne.setName("Air France");
-      firstOne.setCompany(frenchOne);
-      manager.persist(firstOne);
-      return firstOne;
+      return createFlight(1, "AF0101", "Air France");
    }
 
    public void manyToManyCreate() throws Exception
    {
 
-      Flight firstOne = findFlightById(new Long(1));
-      Flight second = new Flight();
-      second.setId(new Long(2));
-      second.setName("US1");
-      Company us = new Company();
-      us.setName("USAir");
-      second.setCompany(us);
+      Flight firstOne = createFlight(2, "KL800", "Air France Aliance");
+      Flight second = createFlight(3, "US1", "USAir");
 
       Set<Customer> customers1 = new HashSet<Customer>();
       Set<Customer> customers2 = new HashSet<Customer>();
Index: testsuite/src/test/java/org/jboss/ejb3/test/manytomany/unit/EntityUnitTestCase.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/manytomany/unit/EntityUnitTestCase.java	(revision 114651)
+++ testsuite/src/test/java/org/jboss/ejb3/test/manytomany/unit/EntityUnitTestCase.java	(working copy)
@@ -93,10 +93,10 @@
       EntityTest test = (EntityTest) this.getInitialContext().lookup("EntityTestBean/remote");
       test.manyToManyCreate();
 
-      Flight one = test.findFlightById(new Long(1));
-      assertTrue(one.getCompany().getName().equals("Air France"));
+      Flight one = test.findFlightById(new Long(2));
+      assertTrue(one.getCompany().getName().equals("Air France Aliance"));
 
-      Flight two = test.findFlightById(new Long(2));
+      Flight two = test.findFlightById(new Long(3));
       assertTrue(two.getCompany().getName().equals("USAir"));
 
       System.out.println("Air France customers");